package robocode.battle;

import java.io.*;
import java.util.Properties;

public class BattleProperties implements Serializable {

    private Properties props = null;
    private int battlefieldWidth = 0;
    private int battlefieldHeight = 0;
    private int numRounds = 0;
    private double gunCoolingRate = 0;
    private long inactivityTime = 0;
    private String selectedRobots = null;
    public static final String BATTLEFIELD_WIDTH = "robocode.battleField.width";
    public static final String BATTLEFIELD_HEIGHT = "robocode.battleField.height";
    public static final String BATTLE_NUMROUNDS = "robocode.battle.numRounds";
    public static final String BATTLE_GUNCOOLINGRATE = "robocode.battle.gunCoolingRate";
    public static final String BATTLE_RULES_INACTIVITYTIME = "robocode.battle.rules.inactivityTime";
    public static final String BATTLE_SELECTEDROBOTS = "robocode.battle.selectedRobots";

    public BattleProperties() {
        props = new Properties();
        battlefieldWidth = 800;
        battlefieldHeight = 600;
        numRounds = 10;
        gunCoolingRate = 0.10000000000000001D;
        inactivityTime = 450L;
    }

    public int getBattlefieldWidth() {
        return battlefieldWidth;
    }

    public void setBattlefieldWidth(int battlefieldWidth) {
        this.battlefieldWidth = battlefieldWidth;
        props.setProperty("robocode.battleField.width", "" + battlefieldWidth);
    }

    public int getBattlefieldHeight() {
        return battlefieldHeight;
    }

    public void setBattlefieldHeight(int battlefieldHeight) {
        this.battlefieldHeight = battlefieldHeight;
        props.setProperty("robocode.battleField.height", "" + battlefieldHeight);
    }

    public int getNumRounds() {
        return numRounds;
    }

    public void setNumRounds(int numRounds) {
        this.numRounds = numRounds;
        props.setProperty("robocode.battle.numRounds", "" + numRounds);
    }

    public double getGunCoolingRate() {
        return gunCoolingRate;
    }

    public void setGunCoolingRate(double gunCoolingRate) {
        this.gunCoolingRate = gunCoolingRate;
        props.setProperty("robocode.battle.gunCoolingRate", "" + gunCoolingRate);
    }

    public long getInactivityTime() {
        return inactivityTime;
    }

    public void setInactivityTime(long inactivityTime) {
        this.inactivityTime = inactivityTime;
        props.setProperty("robocode.battle.rules.inactivityTime", "" + inactivityTime);
    }

    public String getSelectedRobots() {
        return selectedRobots;
    }

    public void setSelectedRobots(String selectedRobots) {
        this.selectedRobots = selectedRobots;
        props.setProperty("robocode.battle.selectedRobots", "" + selectedRobots);
    }

    public void store(FileOutputStream out, String desc) throws IOException {
        props.store(out, desc);
    }

    public void load(FileInputStream in) throws IOException {
        props.load(in);
        battlefieldWidth = Integer.parseInt(props.getProperty("robocode.battleField.width", "800"));
        battlefieldHeight = Integer.parseInt(props.getProperty("robocode.battleField.height", "600"));
        gunCoolingRate = Double.parseDouble(props.getProperty("robocode.battle.gunCoolingRate", "0.1"));
        inactivityTime = Long.parseLong(props.getProperty("robocode.battle.rules.inactivityTime", "450"));
        numRounds = Integer.parseInt(props.getProperty("robocode.battle.numRounds", "10"));
        selectedRobots = props.getProperty("robocode.battle.selectedRobots", "");
    }
}
